package com.blamejared.compat.botania.handlers;

import vazkii.botania.api.BotaniaAPI;
import net.minecraft.util.text.TextFormatting;
import stanhebben.zenscript.annotations.ZenMethod;
import crafttweaker.IAction;
import com.blamejared.compat.botania.LocalizationHelper;
import crafttweaker.CraftTweakerAPI;
import crafttweaker.annotations.ZenRegister;
import crafttweaker.annotations.ModOnly;
import stanhebben.zenscript.annotations.ZenClass;

@ZenClass("mods.botania.Knowledge")
@ModOnly("botania")
@ZenRegister
public class Knowledge
{
    private static final String typeName = "Botania Knowledge Variable:";
    
    @ZenMethod
    public static void registerKnowledgeType(final String unlocalized, final String localized, final String color, final boolean autoUnlock) {
        if (unlocalized == null || unlocalized.isEmpty()) {
            CraftTweakerAPI.logError("Found null String in Botania Knowledge Variable: name");
        }
        else if (color == null || color.isEmpty()) {
            CraftTweakerAPI.logError("Found null String in Botania Knowledge Variable: color");
        }
        else {
            LocalizationHelper.setLocale("botania.knowledge." + unlocalized, localized);
            CraftTweakerAPI.apply((IAction)new Add(unlocalized, color, autoUnlock));
        }
    }
    
    private static class Add implements IAction
    {
        String unlocalized;
        String color;
        boolean autoUnlock;
        
        public Add(final String name, final String color, final boolean autoUnlock) {
            this.unlocalized = name;
            this.color = color;
            this.autoUnlock = autoUnlock;
        }
        
        public void apply() {
            BotaniaAPI.registerKnowledgeType(this.unlocalized, TextFormatting.func_96300_b(this.color.toUpperCase()), this.autoUnlock);
        }
        
        public String describe() {
            String Output;
            if (this.autoUnlock) {
                Output = "Enabled";
            }
            else {
                Output = "Disabled";
            }
            return "Adding Knowledge Type: " + this.unlocalized + " With Auto-Unlock: " + Output;
        }
    }
}
